import com.ibm.ruler.*;
import java.util.*;
import java.awt.*;

/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	
	IPeasant myP[];
	ICastle  myC[];
	IKnight  myK[];
	IRuler   enR[];
	boolean  makingPeasants = true;
	Random rand = new Random();
	int myCX;
	int myCY;
	int myDir = 1;
	Point myPoint;
	boolean dance = true;
	
	int OPT_PAWNS = 30;
	
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	public String getRulerName() {
		return "James";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "UCSDeezNuts";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	public void initialize() {		
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	public void orderSubjects(int lastMoveTime) {

		myP = getPeasants();
		myK = getKnights();
		myC = getCastles();
		
		myCX = myC[0].getX();
		myCY = myC[0].getY();

		makePeeps();	
		
		if( myP.length < OPT_PAWNS )
			randomPawnMove();
		else
			squareDancePawns();

	}
	
	// after pawns are sufficiently (randomly) spread around...
	private void squareDancePawns() {
		
		boolean u = false;
		boolean d = false;
		boolean l = false;
		boolean r = false;
		
		
		int length = rand.nextInt(10) + 50;
		
		for( int x=0; x<myP.length; x++ ) {
			for( int y=0; y<length; y++ ) {
				move( myP[x], myDir );
			}
		}
		

		for( int x=0; x<myP.length; x++ ) {
			if( myP[x].getX() <= 3 )
				l = true;
			if( myP[x].getX() >= 67 )
				r = true;
			if( myP[x].getY() <= 3 )
				u = true;
			if( myP[x].getY() >= 59 )
				d = true;
		}
	
		if( u && r )
			myDir = 7;
		else if ( u && l )
			myDir = 5;
		else if ( d && l )
			myDir = 3;
		else if ( d && r )
			myDir = 1;	
		else 	
			myDir = (myDir - 2) % 8;
	}	
	
	
	// random beginning pawn movement, stay 6dist away from our root
	private void randomPawnMove(){
		for( int x=0; x<myP.length; x++ )
		{
			int distance = myP[x].getDistanceTo( myCX, myCY );
	
			if( distance < 6 )
			{
				myDir = ( myP[x].getDirectionTo( myCX, myCY )+4 )%8;
				myPoint = World.getPositionAfterMove( myP[x].getX(), myP[x].getY(), myDir);
			}
	
			else
			{
				myDir = rand.nextInt(8)+1;
		
			}		
	
			for( int y=0; y<50; y++ )
				move( myP[x], myDir );
	
		}
	}
	
	
	// Decide to make peasants or knights ///////////////////////
	private void makePeeps() {
		if( myP.length > OPT_PAWNS )
			makingPeasants = false;
		else
			makingPeasants = true;

		if( makingPeasants )
			for( int x=0; x<myC.length; x++ )
				createPeasants( myC[x] );
		else
			for( int x=0; x<myC.length; x++ )
				createKnights( myC[x] );
	}
}
