import com.ibm.ruler.IPeasant;
import com.ibm.ruler.IKnight;
import com.ibm.ruler.Ruler;
import com.ibm.ruler.World;
import java.util.*;


/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	Random rand = new Random();
	int xsize = 0, ysize = 0;
	int xrand=rand.nextInt(23443857), 	yrand=rand.nextInt(23443857);

	int dirs[] = { 8, 1, 2, 7, 0, 3, 6, 5, 4 };
	
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	 
	public String getRulerName() {
		return "Land Crawler (demo)";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "Team 99l";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	public void initialize() {
		xsize = 64/*World.WIDTH*/;
		ysize = 72/*World.HEIGHT*/;
		// put implementation here
		
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	public void orderSubjects(int lastMoveTime) {
		// put implementation here
		IKnight[] knights = getKnights();
				int size = knights.length;
				for(int i=0; i<size; i++){ move(knights[i],4);}
		IPeasant[] peasants = getPeasants();
		 size = peasants.length;
		for(int i=0; i<size; i++){
	
			int id = peasants[i].getId();
			int xdelta = peasants[i].getX()-((xrand+id*234321) % xsize);
			int ydelta = peasants[i].getY()-((yrand+id*454547) % ysize);
			if( xdelta != 0 ) xdelta /= -Math.abs(xdelta);
			if( ydelta != 0 ) ydelta /= -Math.abs(ydelta);
			int dir = dirs[xdelta+3*ydelta+4];
			if( dir == 0 ){
				dir = rand.nextInt(8)+1;
				xrand=rand.nextInt(23443857);
				yrand=rand.nextInt(23443857);
				}
		
			
		move(peasants[i],dir);
	
		}
	}
}