import com.ibm.ruler.*;
import java.util.*;
import java.awt.Point;


/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	public String getRulerName() {
		return "MrMoneyBags";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "TeamDini";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	protected Random rand;
	final int width = World.WIDTH;
	final int height = World.HEIGHT;
	boolean not_mine[][];	
	boolean not_minediv10[][];
	int pcountdiv10[][];
	int x_dir[];
	int y_dir[];
	
	public void initialize() {
		x_dir = new int[9];
		y_dir = new int[9];
		rand = new Random();
		not_mine = new boolean[width][height];
		not_minediv10 = new boolean[width][height];
		pcountdiv10 = new int[width][height];
		for (int x=0;x<width;x++) {		
			for (int y=0;y<height;y++)
				not_mine[x][y] = true;
		}
		x_dir[0] = 0;
		x_dir[1] = 0; // up
		x_dir[2] = 1;
		x_dir[3] = 1;
		x_dir[4] = 1;
		x_dir[5] = 0;
		x_dir[6] = -1;
		x_dir[7] = -1;
		x_dir[8] = -1;
		y_dir[0] = 0;
		y_dir[1] = -1; // up
		y_dir[2] = -1;
		y_dir[3] = 0;
		y_dir[4] = 1;
		y_dir[5] = 1;
		y_dir[6] = 1;
		y_dir[7] = 0;
		y_dir[8] = -1;
		// put implementation here
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	private int newx(IObject o, int dir) {
		int retval;
		retval = o.getX()+x_dir[dir];
		//System.out.println("X="+retval+" ");
		if (retval<0)
			return(0);
		else if (retval>=width)
			return(width-1);
		else
			return(retval);
	}
	private int newy(IObject o, int dir) {
		
		int retval;
		retval = o.getY()+y_dir[dir];
		if (retval<0)
			return(0);
		else if (retval>=height)
			return(height-1);
		else
			return(retval);
	}
	
	public void killneighbor(IKnight myk) {
		// capture a knight if it is close
					for (int j=1;j<9;j++) {
						Point np = World.getPositionAfterMove(myk.getX(),myk.getY(), j);
						if (np!=null) {
							IObject object = World.getObjectAt(np.x,np.y);
							if (object!=null && !object.getRuler().equals(myk.getRuler())) {
								System.out.println("attack: "+myk.getX()+" "+myk.getY());
								if (object.getClass()==IKnight.class)
									System.out.println(" strngth=" +((IKnight)object).getStrength());
								
								capture(myk,j);
							}
						
						}
					}
	}
	
	public void movetowards(IObject ok[], IKnight myk[], int avgx,int avgy){
		int kdestx=width/2;
		int kdesty=height/2;
		int kdestdist = width+height;

		if (ok.length==0)
			return;
		for (int i=0;i<ok.length;i++) {
			if ( ok[i].getDistanceTo(avgx,avgy) < kdestdist ) {
				kdestdist = ok[i].getDistanceTo(avgx,avgy);
				kdestx = ok[i].getX();
				kdesty = ok[i].getY();
			}
		}
		for (int i=0;i<myk.length;i++) {
			Point where = World.getPositionAfterMove(
					myk[i].getX(),
					myk[i].getY(),
					myk[i].getDirectionTo(kdestx,kdesty)
				); 
			if (	(where!=null)
					&&						
					(null==World.getObjectAt(where.x,where.y))
				)
				move(myk[i],myk[i].getDirectionTo(kdestx,kdesty));
					
			killneighbor(myk[i]);
		}
		
	}

	public void orderSubjects(int lastMoveTime) {
		// put implementation here
		//System.out.println(lastMoveTime);
		
		
		for (int x=0;x<width;x++) {		
					for (int y=0;y<height;y++){
							not_minediv10[x][y] = false;
							pcountdiv10[x/10][y/10] = 0;
					}
		}
		
		IPeasant[] otp = World.getOtherPeasants();
		IPeasant[] my_p = getPeasants();
		for (int i=0;i<my_p.length;i++) {
			move(my_p[i],rand.nextInt(8)+1);
			pcountdiv10[ my_p[i].getX()/10][my_p[i].getY()]++;
		}
		
		int mycount = 0;

		
		for (int x=0;x<width;x++) {		
			for (int y=0;y<height;y++){
				
				//System.out.println("checking "+x+" "+y);
				not_mine[x][y]=true;
				if (World.getLandOwner(x,y)!=null)
					if (World.getLandOwner(x,y).getRulerName() == getRulerName()) {
						not_mine[x][y] = false;
						mycount++;
					} else {
						not_mine[x][y] = true;
						not_minediv10[x/10][y/10] = true;
					}						
			}
		}
		System.out.println("my count="+mycount);
		

		for (int i=0;i<my_p.length;i++) {
			//System.out.println("checking p at "+my_p[i].getX()+" "+my_p[i].getY());
			for (int dir=1;dir<9;dir++){			
				//System.out.println("moved "+dir+" "+newx(my_p[i],dir)+" "+newy(my_p[i],dir));
				if (not_mine[newx(my_p[i],dir)][newy(my_p[i],dir)]){					
					move(my_p[i],dir);
				}
			}
				

		}
		
		IKnight[] myk = getKnights();
		IKnight[] okn = World.getOtherKnights();
		for (int i=0;i<okn.length;i++)
			System.out.println("okn "+okn[i].getStrength()+" "+okn[i].getX()+" "+okn[i].getY());
		ICastle[] ok = World.getOtherCastles();
		int avgx=0,avgy=0;

		if (myk.length>0) {				
			for (int i=0;i<myk.length;i++) {
				move(myk[i],rand.nextInt(8)+1); // move all of them randomly
				avgx+=myk[i].getX();
				avgy+=myk[i].getY();			
			}
			avgx/=myk.length;
			avgy/=myk.length;
			
				// select a knight to send all of the knights to.
				


			movetowards(World.getOtherPeasants(),myk,avgx,avgy); // Peasants	
			movetowards(okn,myk,avgx,avgy); // knights
			movetowards(ok,myk,avgx,avgy); // castles

			// keep some of the knights at our own castle.
			for (int c=0;c<getCastles().length;c++) {		
				if (getKnights().length < 8*getCastles().length)
					createKnights(getCastles()[c]);
				else if (getPeasants().length > getKnights().length)
					createKnights(getCastles()[c]);
				else
					createPeasants(getCastles()[c]);		
				int num=getKnights().length/(getCastles().length+1);
				ICastle onecastle[] = new ICastle[1];
				IObject somekns[] = new IKnight[num];
				
				onecastle[0] = getCastles()[c];
				for (int k=0;k<num;k++)
					somekns[k]=getKnights()[k+num*c];
				movetowards((IObject [])onecastle,(IKnight[])somekns,avgx,avgy);
				
			}	
		}
		

		
		
	}
}