import com.ibm.ruler.*;
import java.util.*;

/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	
	Group groupVec[];
	int knightsNum;
	Random rand;
		
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	public String getRulerName() {
		return "100 Gram";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "Team 28";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	public void initialize() {
		rand = new Random();
		knightsNum = getKnights().length;
		groupVec = new Group[World.getOtherRulers().length +1];
		for(int i=0;i<World.getOtherRulers().length+1;i++){
			groupVec[i] = new Group();
		}
		
		//System.out.println("Groupvec.lenght" + groupVec.length);
		int size = getKnights().length;
		IKnight knights[] = getKnights();
		for (int i=0;i<size;i++) {
			if(i<(size/2)) {
				groupVec[0].knights.add(knights[i]);
				//System.out.println("huynya g1"); //print statement
			}
			else {
				groupVec[1].knights.add(knights[i]);
				//System.out.println("huynya g2"); //print statement
			}
		}
		//System.out.println(g1.knights.size()); //print statement
		groupVec[0].castle = getCastles()[0];
		ICastle castles[]= World.getOtherCastles();
		int minLength = 10000;
		for(int i = 0;i<castles.length;i++) {
			if(minLength>groupVec[0].castle.getDistanceTo(castles[i].getX(), castles[i].getY())) {
				groupVec[1].castle = castles[i];
				minLength = groupVec[0].castle.getDistanceTo(castles[i].getX(), castles[i].getY());
			}
		}
		int j=2;
		for(int i = 0;i<castles.length;i++) {
			if(!castles[i].equals(groupVec[1].castle)) {
				groupVec[j].castle = castles[i];
				j++;
			}
		}
	}
	private void movePeasant(IPeasant k){
		try{
		
		int kx = k.getX();
		int ky = k.getY();
		if((World.getObjectAt(kx+1,ky)==null) && World.getLandOwner(kx+1,ky)!= null && !World.getLandOwner(kx+1,ky).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_E);
		}
		else if((World.getObjectAt(kx,ky+1)==null) && World.getLandOwner(kx,ky+1)!= null && !World.getLandOwner(kx,ky+1).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_S);
		}
		else if((World.getObjectAt(kx-1,ky)==null) && World.getLandOwner(kx-1,ky)!= null && !World.getLandOwner(kx-1,ky).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_W);
		}
		else if((World.getObjectAt(kx,ky-1)==null) && World.getLandOwner(kx,ky-1)!= null && !World.getLandOwner(kx,ky-1).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_N);
		}
		else if((World.getObjectAt(kx+1,ky+1)==null) && World.getLandOwner(kx+1,ky+1)!= null && !World.getLandOwner(kx+1,ky+1).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_SE);
		}
		else if((World.getObjectAt(kx-1,ky+1)==null) && World.getLandOwner(kx-1,ky+1) != null && !World.getLandOwner(kx-1,ky+1).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_SW);
		}
		else if((World.getObjectAt(kx+1,ky-1)==null) && World.getLandOwner(kx+1,ky-1) != null && !World.getLandOwner(kx+1,ky-1).getRulerName().equals(getRulerName())) {
		
			move(k, MOVE_NE);
		}
		else if((World.getObjectAt(kx-1,ky-1)==null) && World.getLandOwner(kx-1,ky-1) != null && !World.getLandOwner(kx-1,ky-1).getRulerName().equals(getRulerName())) {
			move(k, MOVE_NW);
		}
		else {
			int r = rand.nextInt(World.getOtherCastles().length);
			move(k,k.getDirectionTo(World.getOtherCastles()[r].getX(),World.getOtherCastles()[r].getY()));
		}
		}catch(Exception e){
			//
		}
		
	}
	private void moveKnightToward(IKnight k, IObject o) {
		
		int x = o.getX();
		int y = o.getY();
		int kx = k.getX();     
		int ky = k.getY();
		try{
		//System.out.println("Knight "+k.getRuler().getRulerName()+" "+kx+ " "+ky+" "+(k instanceof IKnight));
		if((World.getObjectAt(kx+1,ky)!=null) && !(World.getObjectAt(kx+1,ky).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_E);
		}
		else if(World.getObjectAt(kx,ky+1)!= null && !(World.getObjectAt(kx,ky+1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_S);
		}
		else if(World.getObjectAt(kx-1,ky)!= null && !(World.getObjectAt(kx-1,ky).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_W);
		}
		else if(World.getObjectAt(kx,ky-1)!= null && !(World.getObjectAt(kx,ky-1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_N);
		}
		else if(World.getObjectAt(kx+1,ky+1)!= null && !(World.getObjectAt(kx+1,ky+1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_SE);
		}
		else if(World.getObjectAt(kx-1,ky+1)!= null && !(World.getObjectAt(kx-1,ky+1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_SW);
		}
		else if(World.getObjectAt(kx+1,ky-1)!= null && !(World.getObjectAt(kx+1,ky-1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_NE);
		}
		else if(World.getObjectAt(kx-1,ky-1)!= null && !(World.getObjectAt(kx-1,ky-1).getRuler().getRulerName().equals(getRulerName()))) {
			capture(k, MOVE_NW);
		}
		else {
			if(World.getObjectAt(x,y)!= null && (World.getObjectAt(x,y).getRuler().getRulerName().equals(getRulerName()))) {
				//System.out.println("someone's in the way!");
				move(k,rand.nextInt(8)+1);
			}
			else{
				//System.out.println("Free to go, URA!");
	
					move(k,k.getDirectionTo(x,y));

			}
		}
		}catch(Exception e){
			//move(k,rand.nextInt(8)+1);
		}
			
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	public void orderSubjects(int lastMoveTime) {
		
		ICastle castles[] = getCastles();
		for(int i=0;i<castles.length;i++){
			if(i%2 == 1)
				createKnights(castles[i]);
			else
				createPeasants(castles[i]);
		}
		IPeasant peasants[] = getPeasants();
		for(int i=0;i<peasants.length;i++){
			movePeasant(peasants[i]);
		}
		IKnight allKnights[] = getKnights();

		if(knightsNum != allKnights.length){
			//System.out.println("Knight produced");
			knightsNum = allKnights.length;
			for(int k=0;k<allKnights.length;k++){
				int found = 0;
				Group curGroup = null;
				IKnight curKnight = null;
				for(int i=0;i<groupVec.length;i++) {
					curGroup = (Group)groupVec[i];
					for (int j=0;j<curGroup.knights.size();j++) {
						//System.out.println("KnightSize: " + curGroup.knights.size());
						curKnight = (IKnight)(curGroup).knights.elementAt(j);
						if(allKnights[k].equals(curKnight)){
							//System.out.println("Found knight");
							found = 1;
							break;
						}
					}
					if(found==1)
						break;
				}
				if(found != 1){
					//System.out.println("adding knight");
					groupVec[castles.length].knights.add(allKnights[k]);
				}
			}
		}
		
		//System.out.println("LastMoveTime: " + lastMoveTime);
		for(int i=0;i<groupVec.length;i++) {
			//System.out.println("GroupVecSize: " + groupVec.size());
			Group curGroup = (Group)groupVec[i];
			//System.out.println("size of knights: " + curGroup.knights.size());
			for (int j=0;j<curGroup.knights.size();j++) {
				//System.out.println("KnightSize: " + curGroup.knights.size());
				IKnight curKnight = (IKnight)(curGroup).knights.elementAt(j);
				if(!curGroup.castle.getRuler().getRulerName().equals(getRulerName())) {
					//System.out.println("let's go!");
					moveKnightToward(curKnight, curGroup.castle);
				}
				else {
					IKnight [] otherK = World.getOtherKnights();
					IPeasant [] otherP = World.getOtherPeasants();
					
					int min = 10000;
					
					IObject target = null;
					for(int k=0;k<otherK.length;k++){
						if(curGroup.castle.getDistanceTo(otherK[k].getX(),otherK[k].getY()) < min){
							min = curGroup.castle.getDistanceTo(otherK[k].getX(),otherK[k].getY());
							target = otherK[k];
						}
					}
					for(int k=0;k<otherP.length;k++){
						if(curGroup.castle.getDistanceTo(otherP[k].getX(),otherP[k].getY()) < min){
							min = curGroup.castle.getDistanceTo(otherP[k].getX(),otherP[k].getY());
							target = otherP[k];
						}
					}
					ICastle c[] = World.getOtherCastles();
					for(int k=0;k<c.length;k++){
						if(curGroup.castle.getDistanceTo(c[k].getX(),c[k].getY()) < min){
							min = curGroup.castle.getDistanceTo(c[k].getX(),c[k].getY());
							target = c[k];
						}
					}
					if(target != null){
						//System.out.println("Calling move");
						moveKnightToward(curKnight,target);
					}
				}
			}
		}


		// divide knights into responsibility groups
		// (do this every time we get a new castle captured)
		// have each group assume its position
		//     first priority: capture castle
		//     second priority: kill other knights
		//     last priority: kill peasants
	}
	
	private class Group {
		ICastle castle = null;
		Vector knights;
		
		Group () {
			knights = new Vector();
		}
	}
}