import com.ibm.ruler.*;

/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	public String getRulerName() {
		return "Gordon";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "Team 34";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	public void initialize() {
		// put implementation here
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	public void orderSubjects(int lastMoveTime) {
		IKnight myKnights[] = getKnights();
		IPeasant myPeasants[] = getPeasants();
		ICastle myCastles[] = getCastles();
		
		otherKnights = World.getOtherKnights();
		otherPeasants = World.getOtherPeasants();
		otherCastles = World.getOtherCastles();

		int players=World.getOtherRulers().length;
		
			
		//What to produce?
		if (World.getOtherKnights().length == 0 || World.getOtherPeasants().length == 0)
			for (int i=myCastles.length-1; i>0; i--)
				createPeasants(myCastles[i]);
		else if (myKnights.length / World.getOtherKnights().length >
		    myPeasants.length / World.getOtherPeasants().length )
			for (int i=myCastles.length-1; i>0; i--)
				createPeasants(myCastles[i]);
		else
			for (int i=myCastles.length-1; i>0; i--)
				createKnights(myCastles[i]);
		

		if (pt_reached == true || kt_reached == true)
			calcDist();
		//Pesants path finding
		if (pt_reached == true)
		{
			int min_peasants=4000, best_castle=0, i;
			if (otherCastles.length == 0)
			{//random target
				System.out.println("done ");
			}
			else
			{
				for (i=otherCastles.length-1; i>0; i--)
			
				if (counts[i][0]<min_peasants){
					min_peasants=counts[i][0];
					best_castle=i;
				}
				pt_x=otherCastles[i].getX();
				pt_y=otherCastles[i].getY();
				
			}
			System.out.println("Peasants x:"+pt_x+" y:"+pt_y);
			pt_reached = false;
		}
		
		for (int i= myPeasants.length-1; i>0; i--)
		{
			//Capture any adjacent Units
			int x=myPeasants[i].getX(), y=myPeasants[i].getY();
			int dir = myPeasants[i].getDirectionTo(pt_x,pt_y);
			java.awt.Point p = World.getPositionAfterMove(x,y,dir);
			
			//Target reached
			if ((x == pt_x && y==pt_y) || (p.x == pt_x && p.y == pt_y))
				pt_reached = true;	
			
			if ( World.getObjectAt(x-1,y-1) == null && World.getLandOwner(x-1,y-1) != this && feasible(x-1, y-1))
				move(myPeasants[i],MOVE_NW);
			else if ( World.getObjectAt(x,y-1) == null && World.getLandOwner(x,y-1) != this && feasible(x, y-1))
				move(myPeasants[i],MOVE_N);
			else if ( World.getObjectAt(x+1,y-1) == null && World.getLandOwner(x+1,y-1) != this && feasible (x+1, y-1))
				move(myPeasants[i],MOVE_NE);
			else if ( World.getObjectAt(x+1,y) == null && World.getLandOwner(x+1,y) != this && feasible (x+1,y))
				move(myPeasants[i],MOVE_E);
			else if ( World.getObjectAt(x+1,y+1) == null && World.getLandOwner(x+1,y+1) != this && feasible (x+1,y+1))
				move(myPeasants[i],MOVE_SE);
			else if ( World.getObjectAt(x,y+1) == null && World.getLandOwner(x,y+1) != this && feasible(x,y+1))
				move(myPeasants[i],MOVE_S);
			else if ( World.getObjectAt(x-1,y+1) == null && World.getLandOwner(x-1,y+1) != this && feasible (x-1,y+1))
				move(myPeasants[i],MOVE_SW);
			else if ( World.getObjectAt(x-1,y) == null && World.getLandOwner(x-1,y) != this && feasible (x-1,y))
				move(myPeasants[i],MOVE_W);
		
			//Move toward target Castle
			else
				move(myPeasants[i], dir);
		}		
		
		//Knight
		if (kt_reached == true)
		{
			int i;
			int min_knights=4000;
			int best_castle=0;
		
			if (otherCastles.length == 0)
				System.out.println("Knight done");
			else
			{
				for (i=otherCastles.length-1; i>0; i--)
					if (counts[i][0]<min_knights){
						min_knights=counts[i][0];
						best_castle=i;
					}
				kt_x=otherCastles[i].getX();
				kt_y=otherCastles[i].getY();
				
			}
			kt_reached = false;
			System.out.println(" Knights x:"+kt_x+" y:"+kt_y+"\n");
		}
		for (int i= myKnights.length-1; i>0; i--)
		{
			//Capture any adjacent Units
			int x=myKnights[i].getX(), y=myKnights[i].getY();
			int dir = myKnights[i].getDirectionTo(kt_x,kt_y);
			java.awt.Point p = World.getPositionAfterMove(x,y,dir);
						
			if ((kt_x == p.x && kt_y == p.y) || (x==kt_x && y==kt_y) )
				kt_reached = true;
			
			if ( World.getObjectAt(x-1,y-1) != null && World.getObjectAt(x-1,y-1).getRuler() != this)
				capture(myKnights[i],MOVE_NW);
			else if ( World.getObjectAt(x,y-1) != null && World.getObjectAt(x,y-1).getRuler() != this)
				capture(myKnights[i],MOVE_N);
			else if ( World.getObjectAt(x+1,y-1) != null && World.getObjectAt(x+1,y-1).getRuler() != this)
				capture(myKnights[i],MOVE_NE);
			else if ( World.getObjectAt(x+1,y) != null && World.getObjectAt(x+1,y).getRuler() != this)
				capture(myKnights[i],MOVE_E);
			else if ( World.getObjectAt(x+1,y+1) != null && World.getObjectAt(x+1,y+1).getRuler() != this)
				capture(myKnights[i],MOVE_SE);
			else if ( World.getObjectAt(x,y+1) != null && World.getObjectAt(x,y+1).getRuler() != this)
				capture(myKnights[i],MOVE_S);
			else if ( World.getObjectAt(x-1,y+1) != null && World.getObjectAt(x-1,y+1).getRuler() != this)
				capture(myKnights[i],MOVE_SW);
			else if ( World.getObjectAt(x-1,y) != null && World.getObjectAt(x-1,y).getRuler() != this)
				capture(myKnights[i],MOVE_W);
		
			//Move toward target Castle
			else if (World.getObjectAt(p.x, p.y) == null)
				move(myKnights[i], dir);
			else
				move(myKnights[i],free_dir(myKnights[i]));
		}
	}
	
	boolean feasible (int x, int y)
	{
		if (x <= World.WIDTH-1 && x>=0 && y>= 0 && y<=World.HEIGHT-1)
			return true;
		return false;
	}
	
	public int free_dir(IObject o){
		int x = o.getX(), y = o.getY();
		if ( World.getObjectAt(x-1,y-1) == null)
			return MOVE_NW;
		else if ( World.getObjectAt(x,y-1) == null)
			return MOVE_N;
		else if ( World.getObjectAt(x+1,y-1) == null)
			return MOVE_NE;
		else if ( World.getObjectAt(x+1,y) == null)
			return MOVE_E;
		else if ( World.getObjectAt(x+1,y+1) == null)
			return MOVE_SE;
		else if ( World.getObjectAt(x,y+1) == null)
			return MOVE_S;
		else if ( World.getObjectAt(x-1,y+1) == null)
			return MOVE_SW;
		else if ( World.getObjectAt(x-1,y) == null)
			return MOVE_W;
		return MOVE_W;
	}
	
	private void calcDist(){
		 int i,j,d,min_j, min_d;
		 
		 if (otherCastles.length == 0)
		 	 return;
		 counts = new int [(otherCastles.length)][2];
		 
		 //tally knights
		 for (i=otherKnights.length-1; i>0; i--)
		 {	
		    min_j=0; min_d=4000;
		 	
		 	for (j=otherCastles.length-1; j>0; j--)
		 	{
		 		d = otherKnights[i].getDistanceTo(otherCastles[j].getX(),otherCastles[j].getY());
		 		if (d<min_d){
		 			min_d=d;
		 			min_j=j;
		 		}
		 	}
		  	counts[min_j][0]++;
		 }
		 
		 //tally peasants
		for (i=otherPeasants.length-1; i>0; i--)
		{	
		   min_j=0; min_d=4000;
		 	
		   for (j=otherCastles.length-1; j>0; j--)
		   {
			   d = otherPeasants[i].getDistanceTo(otherCastles[j].getX(),otherCastles[j].getY());
			   if (d<min_d){
				   min_d=d;
				   min_j=j;
			   }
		   }
		   counts[min_j][1]++;
		}
	}

	IPeasant otherPeasants[];
	ICastle otherCastles[];
	IKnight otherKnights[];
	
	boolean pt_reached = true;
	boolean kt_reached = true;
	
	int kt_x, kt_y, pt_x, pt_y;
	int counts [][];
}