import com.ibm.ruler.*;
import java.util.*;
import java.awt.*;

/**
 * This is the class that you must implement to enable your ruler within
 * the CodeRuler environment. Adding code to these methods will give your ruler
 * its personality and allow it to compete.
 */
public class MyRuler extends Ruler {
	protected Random rand = new Random();
	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getRulerName()
	 */
	public String getRulerName() {
		return "Koopa Troopas";
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#getSchoolName()
	 */
	public String getSchoolName() {
		return "Team 37";
	}

IPeasant[] peasants;
IKnight[] knights;

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#initialize()
	 */
	public void initialize() {
		// put implementation here
		peasants = getPeasants();
		knights = getKnights();
		castle = 0;
	}

	/* (non-Javadoc)
	 * @see com.ibm.ruler.Ruler#orderSubjects(int)
	 */
	public void orderSubjects(int lastMoveTime) {
		int v = rand.nextInt(2);
		switch( v)
		{
			case 0:
				createK();
				knights = getKnights();
			break;
			case 1:
				createP();
				peasants = getPeasants();
		}
		  movePeasants();
		  moveKnights();
	}
	
	public void createK()
	{
		ICastle[] c = getCastles();
		for( int i = 0; i< c.length; i++ )
		{
			createKnights( c[i] );
		}
	}
	
	public void createP()
	{
		ICastle[] c = getCastles();
		for( int i = 0; i < c.length; i++ )
		{
			createPeasants( c[i] );
		}
	}
	public void moveKnights()
	{
		int size = knights.length;
		for( int i = 0; i < size; i++ )
		{
			if( i < 4 )
			{
				knightCapture( knights[i] );
			}
			else if( i < 7 )
			{
				knightMove(knights[i], 0 );
			}
			else 
			{
				knightMove( knights[i], 1 );
			}
		}
	}
	
	int castle;
	
	public void knightMove( IKnight k, int num )
	{
		ICastle[] castle1 = World.getOtherCastles();
		ICastle c = castle1[num];

		int kX = k.getX();
		int kY = k.getY();
		int cX = c.getX();
		int cY = c.getY();
		
		int x = kX - cX;
		int y = kY - cY;
		if( x < 0 && y < 0 )
		{
			if( ! knightCapture( k ) )
			{
				move( k, MOVE_SE );
			}
		}
		else if( x < 0 && y > 0 )
		{
			if( ! knightCapture( k ) )
			{
				move( k, MOVE_NE );
			}
		}
		else if( x > 0 && y < 0 )
		{
			if( ! knightCapture( k ) )
			{
				move( k, MOVE_SW );
			}
		}
		else if( x > 0 && y > 0 )
		{
			if( !knightCapture( k ) )
			{
				move( k, MOVE_NW );
			}
		}
		else if( x == 0 && y < 0 )
		{
			if( ! knightCapture( k) )
			{
				move( k, MOVE_S );
			}
		}
		else if( x == 0 && y > 0 )
		{
			if( ! knightCapture( k ) )
			{
				move( k, MOVE_N );
			}
		}
		else if( y == 0 && x < 0 )
		{
			if( ! knightCapture( k ) )
			{
			 	move( k, MOVE_E );
			}
		}
		else if( y == 0 && x > 0 )
		{
			if( ! knightCapture( k ) )
			{
				move( k, MOVE_W );
			}
		}
	}
	public boolean knightCapture( IKnight k )
	{
		for( int i = 1; i < 9; i++ )
		{
			Point np = World.getPositionAfterMove( k.getX(), k.getY(), i);
			if( np != null )
			{
				IObject o = World.getObjectAt( np.x, np.y );
				if( o != null && !o.getRuler().equals(k.getRuler()))
				{
					capture( k, i );
					return true;
				}
			}
		}
		return false;
	}
	
	public boolean movePeasants()
	{
		int size = peasants.length;
		for( int i = 0; i < size; i++ )
		{
			move( peasants[i], rand.nextInt(8) + 1);
		}
		return true;
	}
	
}